#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;

namespace ControlsGalore
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;
		private Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor propertyEditor1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItemLink;
		private System.Windows.Forms.MenuItem menuItemOrthogonalLink;
		private System.Windows.Forms.MenuItem menuItemDirectedlineLink;
		private System.Windows.Forms.MenuItem menuItemArcLink;
		private System.Windows.Forms.OpenFileDialog openDiagramDialog;
		private System.Windows.Forms.SaveFileDialog saveDiagramDialog;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.MenuItem menuEdit;
		private Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView paletteGroupView1;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton tbInsertSymbol;
		private System.Windows.Forms.ToolBarButton tbControlNodeTool;
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MenuItem menuItemControlNode;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.MenuItem miInsertTextBox;
		private System.Windows.Forms.MenuItem miInsertButton;
		private System.Windows.Forms.MenuItem miInsertControlNode;
		
		private Syncfusion.Windows.Forms.Diagram.InsertSymbolTool insSymbolTool;

		public Form1()
		{
			// The Syncfusion.Windows.Forms.Diagram.ControlNode and Syncfusion.Windows.Forms.Diagram.ActivateStyle types 
			// have been moved from the Syncfusion.Diagram.Base to the Syncfusion.Diagram.Windows assembly.
			// The following binding information is required to correctly resolve the ControlNode and ActivateStyle types.
			string controlnodebinding = "Syncfusion.Windows.Forms.Diagram.ControlNodeSyncfusion.Diagram.Base";
			string activatestylebinding = "Syncfusion.Windows.Forms.Diagram.ActivateStyleSyncfusion.Diagram.Base";
			Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder.TypeNamesVsAssembly.Add(controlnodebinding.ToLower(), typeof(Syncfusion.Windows.Forms.Diagram.Controls.Diagram).Assembly);
			Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder.TypeNamesVsAssembly.Add(activatestylebinding.ToLower(), typeof(Syncfusion.Windows.Forms.Diagram.Controls.Diagram).Assembly);

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.diagram1 = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.paletteGroupView1 = new Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView();
			this.propertyEditor1 = new Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuEdit = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItemLink = new System.Windows.Forms.MenuItem();
			this.menuItemOrthogonalLink = new System.Windows.Forms.MenuItem();
			this.menuItemDirectedlineLink = new System.Windows.Forms.MenuItem();
			this.menuItemArcLink = new System.Windows.Forms.MenuItem();
			this.menuItemControlNode = new System.Windows.Forms.MenuItem();
			this.miInsertTextBox = new System.Windows.Forms.MenuItem();
			this.miInsertButton = new System.Windows.Forms.MenuItem();
			this.miInsertControlNode = new System.Windows.Forms.MenuItem();
			this.openDiagramDialog = new System.Windows.Forms.OpenFileDialog();
			this.saveDiagramDialog = new System.Windows.Forms.SaveFileDialog();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.tbInsertSymbol = new System.Windows.Forms.ToolBarButton();
			this.tbControlNodeTool = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.splitter1 = new System.Windows.Forms.Splitter();
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).BeginInit();
			this.SuspendLayout();
			// 
			// diagram1
			// 
			this.diagram1.AllowDrop = true;
			// 
			// diagram1.Controller
			// 
			this.diagram1.Controller.MaxHistory = 256;
			this.diagram1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram1.HScroll = true;
			this.diagram1.LayoutManager = null;
			this.diagram1.Location = new System.Drawing.Point(104, 28);
			// 
			// diagram1.Model
			// 
			this.diagram1.Model.BackgroundStyle.Color = System.Drawing.Color.White;
			this.diagram1.Model.BackgroundStyle.GradientAngle = 90F;
			this.diagram1.Model.BackgroundStyle.ForeColor = System.Drawing.Color.White;
			this.diagram1.Model.BackgroundStyle.Texture = null;
			this.diagram1.Model.BackgroundStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram1.Model.BackgroundStyle.Type = Syncfusion.Windows.Forms.Diagram.BackgroundStyleType.Solid;
			this.diagram1.Model.BoundaryConstraintsEnabled = true;
			this.diagram1.Model.FillStyle.AlphaFactor = 255;
			this.diagram1.Model.FillStyle.Color = System.Drawing.Color.LightGray;
			this.diagram1.Model.FillStyle.GradientAngle = 90F;
			this.diagram1.Model.FillStyle.ForeColor = System.Drawing.Color.LightGray;
			this.diagram1.Model.FillStyle.Texture = null;
			this.diagram1.Model.FillStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram1.Model.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.Solid;
			this.diagram1.Model.Height = 1056F;
			this.diagram1.Model.LineStyle.DashCap = System.Drawing.Drawing2D.DashCap.Flat;
			this.diagram1.Model.LineStyle.DashOffset = 0F;
			this.diagram1.Model.LineStyle.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
			this.diagram1.Model.LineStyle.EndCap = System.Drawing.Drawing2D.LineCap.Flat;
			this.diagram1.Model.LineStyle.LineColor = System.Drawing.Color.Black;
			this.diagram1.Model.LineStyle.LineJoin = System.Drawing.Drawing2D.LineJoin.Bevel;
			this.diagram1.Model.LineStyle.LineWidth = 2F;
			this.diagram1.Model.LineStyle.MiterLimit = 10F;
			this.diagram1.Model.MeasurementScale = 1F;
			this.diagram1.Model.MeasurementUnits = System.Drawing.GraphicsUnit.Pixel;
			this.diagram1.Model.Name = "Model";
			this.diagram1.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.Default;
			this.diagram1.Model.ShadowStyle.AlphaFactor = 128;
			this.diagram1.Model.ShadowStyle.Color = System.Drawing.Color.LightGray;
			this.diagram1.Model.ShadowStyle.OffsetX = 6F;
			this.diagram1.Model.ShadowStyle.OffsetY = 6F;
			this.diagram1.Model.ShadowStyle.Visible = false;
			this.diagram1.Model.Width = 816F;
			this.diagram1.Name = "diagram1";
			this.diagram1.NudgeIncrement = 1F;
			this.diagram1.ScrollGranularity = 0.5F;
			this.diagram1.Size = new System.Drawing.Size(696, 469);
			this.diagram1.SmartSizeBox = false;
			this.diagram1.TabIndex = 0;
			this.diagram1.Text = "diagram1";
			// 
			// diagram1.View
			// 
			this.diagram1.View.BackgroundColor = System.Drawing.Color.DarkGray;
			this.diagram1.View.Grid.Color = System.Drawing.Color.Black;
			this.diagram1.View.Grid.DashOffset = 4F;
			this.diagram1.View.Grid.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
			this.diagram1.View.Grid.GridStyle = Syncfusion.Windows.Forms.Diagram.GridStyle.Point;
			this.diagram1.View.Grid.HorizontalSpacing = 10F;
			this.diagram1.View.Grid.SnapToGrid = true;
			this.diagram1.View.Grid.VerticalSpacing = 10F;
			this.diagram1.View.Grid.Visible = true;
			this.diagram1.View.HandleAnchorColor = System.Drawing.Color.LightGray;
			this.diagram1.View.HandleColor = System.Drawing.Color.White;
			this.diagram1.View.HandleDisabledColor = System.Drawing.Color.Black;
			this.diagram1.View.HandleSize = 6;
			this.diagram1.View.HorizontalRuler.Visible = false;
			this.diagram1.View.MouseTrackingEnabled = true;
			this.diagram1.View.PasteOffsetX = 10;
			this.diagram1.View.PasteOffsetY = 10;
			this.diagram1.View.RulerFillColor = System.Drawing.Color.LightGray;
			this.diagram1.View.RulerLineColor = System.Drawing.Color.Black;
			this.diagram1.View.RulerSize = 16;
			this.diagram1.View.RulerUnits = Syncfusion.Windows.Forms.Diagram.MeasurementsUnit.Inches;
			this.diagram1.View.ShowPageBounds = true;
			this.diagram1.View.VerticalRuler.Visible = false;
			this.diagram1.VScroll = true;
			this.diagram1.ControlNodeInfo += new Syncfusion.Windows.Forms.Diagram.ControlNodeEventHandler(this.diagram1_ControlNodeInfo);
			// 
			// paletteGroupView1
			// 
			this.paletteGroupView1.Dock = System.Windows.Forms.DockStyle.Left;
			this.paletteGroupView1.EditMode = false;
			this.paletteGroupView1.Location = new System.Drawing.Point(0, 28);
			this.paletteGroupView1.Name = "paletteGroupView1";
			this.paletteGroupView1.Size = new System.Drawing.Size(104, 469);
			this.paletteGroupView1.TabIndex = 1;
			this.paletteGroupView1.Text = "paletteGroupView1";
            this.paletteGroupView1.LoadPalette(System.Reflection.Assembly.GetAssembly(typeof(ControlsGalore.Form1)), "ControlsGalore.Form1", "paletteGroupView1.Palette");
			// 
			// propertyEditor1
			// 
			this.propertyEditor1.Diagram = this.diagram1;
			this.propertyEditor1.Dock = System.Windows.Forms.DockStyle.Right;
			this.propertyEditor1.Location = new System.Drawing.Point(672, 28);
			this.propertyEditor1.Name = "propertyEditor1";
			this.propertyEditor1.Size = new System.Drawing.Size(128, 469);
			this.propertyEditor1.TabIndex = 2;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuEdit,
																					  this.menuItem7});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem6,
																					  this.menuItem4,
																					  this.menuItem5});
			this.menuItem1.Text = "&File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "&New";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "&Open";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 2;
			this.menuItem6.Text = "&Save";
			this.menuItem6.Click += new System.EventHandler(this.menuItem6_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 3;
			this.menuItem4.Text = "-";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 4;
			this.menuItem5.Text = "E&xit";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// menuEdit
			// 
			this.menuEdit.Index = 1;
			this.menuEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItem9,
																					 this.menuItem11,
																					 this.menuItem10,
																					 this.menuItem12});
			this.menuEdit.Text = "Edit";
			this.menuEdit.Click += new System.EventHandler(this.barItemDelete_Click);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 0;
			this.menuItem9.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.menuItem9.Text = "Copy";
			this.menuItem9.Click += new System.EventHandler(this.menuItemCopy_Click);
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 1;
			this.menuItem11.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.menuItem11.Text = "Cut";
			this.menuItem11.Click += new System.EventHandler(this.menuItemCut_Click);
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 2;
			this.menuItem10.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
			this.menuItem10.Text = "Paste";
			this.menuItem10.Click += new System.EventHandler(this.menuItemPaste_Click);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 3;
			this.menuItem12.Shortcut = System.Windows.Forms.Shortcut.Del;
			this.menuItem12.Text = "Delete";
			this.menuItem12.Click += new System.EventHandler(this.barItemDelete_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 2;
			this.menuItem7.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem8,
																					  this.menuItemControlNode});
			this.menuItem7.Text = "&Actions";
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 0;
			this.menuItem8.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemLink,
																					  this.menuItemOrthogonalLink,
																					  this.menuItemDirectedlineLink,
																					  this.menuItemArcLink});
			this.menuItem8.Text = "Add &Link";
			// 
			// menuItemLink
			// 
			this.menuItemLink.Index = 0;
			this.menuItemLink.Text = "Link";
			this.menuItemLink.Click += new System.EventHandler(this.menuItemLink_Click);
			// 
			// menuItemOrthogonalLink
			// 
			this.menuItemOrthogonalLink.Index = 1;
			this.menuItemOrthogonalLink.Text = "Orthogonal Link";
			this.menuItemOrthogonalLink.Click += new System.EventHandler(this.menuItemOrthogonalLink_Click);
			// 
			// menuItemDirectedlineLink
			// 
			this.menuItemDirectedlineLink.Index = 2;
			this.menuItemDirectedlineLink.Text = "Directedline Link";
			this.menuItemDirectedlineLink.Click += new System.EventHandler(this.menuItemDirectedlineLink_Click);
			// 
			// menuItemArcLink
			// 
			this.menuItemArcLink.Index = 3;
			this.menuItemArcLink.Text = "Arc Link";
			this.menuItemArcLink.Click += new System.EventHandler(this.menuItemArcLink_Click);
			// 
			// menuItemControlNode
			// 
			this.menuItemControlNode.Index = 1;
			this.menuItemControlNode.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																								this.miInsertTextBox,
																								this.miInsertButton,
																								this.miInsertControlNode});
			this.menuItemControlNode.Text = "ControlNode Tool";
			// 
			// miInsertTextBox
			// 
			this.miInsertTextBox.Index = 0;
			this.miInsertTextBox.Text = "Insert TextBox";
			this.miInsertTextBox.Click += new System.EventHandler(this.miInsertTextBox_Click);
			// 
			// miInsertButton
			// 
			this.miInsertButton.Index = 1;
			this.miInsertButton.Text = "Insert Button";
			this.miInsertButton.Click += new System.EventHandler(this.miInsertButton_Click_2);
			// 
			// miInsertControlNode
			// 
			this.miInsertControlNode.Index = 2;
			this.miInsertControlNode.Text = "Insert ControlNode";
			this.miInsertControlNode.Click += new System.EventHandler(this.miInsertControlNode_Click);
			// 
			// openDiagramDialog
			// 
			this.openDiagramDialog.Filter = "Diagram Files|*.edd|All files|*.*";
			this.openDiagramDialog.Title = "Open Diagram";
			// 
			// saveDiagramDialog
			// 
			this.saveDiagramDialog.FileName = "doc1";
			this.saveDiagramDialog.Filter = "Diagram files|*.edd|All files|*.*";
			this.saveDiagramDialog.Title = "SaveDiagram";
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.tbInsertSymbol,
																						this.tbControlNodeTool});
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(800, 28);
			this.toolBar1.TabIndex = 3;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// tbInsertSymbol
			// 
			this.tbInsertSymbol.ImageIndex = 0;
			this.tbInsertSymbol.Tag = "InsertSymbol";
			this.tbInsertSymbol.ToolTipText = "Insert TreeSymbol";
			// 
			// tbControlNodeTool
			// 
			this.tbControlNodeTool.ImageIndex = 1;
			this.tbControlNodeTool.Tag = "ControlNodeTool";
			this.tbControlNodeTool.ToolTipText = "Add Control Node";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Right;
			this.splitter1.Location = new System.Drawing.Point(669, 28);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 469);
			this.splitter1.TabIndex = 4;
			this.splitter1.TabStop = false;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(800, 497);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.propertyEditor1);
			this.Controls.Add(this.diagram1);
			this.Controls.Add(this.paletteGroupView1);
			this.Controls.Add(this.toolBar1);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Controls Galore";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void menuItemLink_Click(object sender, System.EventArgs e)
		{
			this.diagram1.ActivateTool("LinkTool");
		}

		private void menuItemOrthogonalLink_Click(object sender, System.EventArgs e)
		{
			this.diagram1.ActivateTool("OrthogonalLinkTool");
		}

		private void menuItemDirectedlineLink_Click(object sender, System.EventArgs e)
		{
			this.diagram1.ActivateTool("DirectedLinkTool");
		}

		private void menuItemArcLink_Click(object sender, System.EventArgs e)
		{
			this.diagram1.ActivateTool("ArcLinkTool");
		}
		
	    #region LinkFactories
	    
		protected Link CreateDirectedLink(PointF[] pts)
		{
			Link link = new Link(pts);
			EndPointDecoratorModel decoratorMdl = Global.EndPointDecoratorPalette["Filled Arrow"];
			if (decoratorMdl != null)
			{
				link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance();
			}
			return link;
		}

		protected Link CreateOrthogonalLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.OrthogonalLine, pts);
			return link;
		}
		protected Link CreateArcLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.Arc, pts);
			return link;
		}
		#endregion
		private void MainForm_Load(object sender, System.EventArgs e)
		{
			this.OpenFile(@"..\..\ControlsGalore.edd");
		}

		private void CreateAndRegisterLinkTools()
		{
			// Create and register a tool for orthogonal links
			LinkTool orthogonalLinkTool = new LinkTool("OrthogonalLinkTool");
			orthogonalLinkTool.LinkFactory = new LinkFactory(this.CreateOrthogonalLink);
			this.diagram1.Controller.RegisterTool(orthogonalLinkTool);
	
			// Create and register a tool for directed links
			LinkTool directedLinkTool = new LinkTool("DirectedLinkTool");
			directedLinkTool.LinkFactory = new LinkFactory(this.CreateDirectedLink);
			this.diagram1.Controller.RegisterTool(directedLinkTool);
	
			// Create and register a tool for arc links
			LinkTool arcLinkTool = new LinkTool("ArcLinkTool");
			arcLinkTool.LinkFactory = new LinkFactory(this.CreateArcLink);
			this.diagram1.Controller.RegisterTool(arcLinkTool);
		}

		private void CreateAndRegisterSymbolTools()
		{			
			// Create and register an InsertSymbolTool for the calendar symbol
			this.insSymbolTool = new InsertSymbolTool("InsertTreeViewSymbol");
			this.diagram1.Controller.RegisterTool(this.insSymbolTool);
		}

		private void barItemDelete_Click(object sender, System.EventArgs e)
		{
			if (this.diagram1 != null)
			{
				this.diagram1.Controller.Delete();			
			}
		}
		#region File Menu Handlers
		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			// Open diagram
			if (this.openDiagramDialog.ShowDialog(this) == DialogResult.OK)
			{
				this.OpenFile(this.openDiagramDialog.FileName);
				this.diagram1.Refresh();
			}
		}

		private void menuItem6_Click(object sender, System.EventArgs e)
		{
			// Save diagram
			Diagram docForm = this.diagram1;
			if (docForm != null)
			{
				if (this.saveDiagramDialog.ShowDialog(this) == DialogResult.OK)
				{
					string fileName = this.saveDiagramDialog.FileName;
					FileStream oStream = null;
			
					try
					{
						oStream = new FileStream(fileName, FileMode.Create);
					}
					catch (Exception ex)
					{
						oStream = null;  // just to be sure
						MessageBox.Show("Error opening " + fileName + " - " + ex.Message);
					}

					if (oStream != null)
					{
						try
						{
							this.diagram1.SaveBinary(oStream);
						}
						catch (Exception ex)
						{
							MessageBox.Show("Serialization error - " + ex.Message);
						}
						finally
						{
							oStream.Close();
						}
					}
				}
			}
		}

		public void OpenFile(string fileName)
		{
			FileStream iStream = new FileStream(fileName, FileMode.OpenOrCreate);
			if (iStream != null)
			{
				this.diagram1.LoadBinary(iStream);
				iStream.Close();
				this.CreateAndRegisterLinkTools();
				this.CreateAndRegisterSymbolTools();
			}
		}
		

		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			this.diagram1.Controller.Delete();
			this.diagram1.Model.Clear();
			this.diagram1.Refresh();
		}
		#endregion

		private void menuItemCopy_Click(object sender, System.EventArgs e)
		{
			Diagram diagram = this.diagram1;
				if (diagram != null)
				{
					diagram.Controller.Copy();
				}
			}

		private void menuItemCut_Click(object sender, System.EventArgs e)
		{
			Diagram diagram = this.diagram1;
			if ( diagram != null )
			{
				diagram.Controller.Cut();
			}
		}

		private void menuItemPaste_Click(object sender, System.EventArgs e)
		{
			Diagram diagram = this.diagram1;
			if ( diagram != null )
			{
				diagram.Controller.Paste();
			}
		}		

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if(e.Button == this.tbInsertSymbol)
			{
				TreeViewSymbol sym = new TreeViewSymbol();
				if (sym != null)
				{
					this.insSymbolTool.Symbol = sym;
					this.diagram1.ActivateTool("InsertTreeViewSymbol");
				}
			}		
			else if(e.Button == this.tbControlNodeTool)
			{
				this.diagram1.ActivateTool("ControlNodeTool");
			}
		}

		// The Diagram.ControlNodeInfo event is generated when a ControlNode requires information 
		// about the Windows Forms control that it contains
		private void diagram1_ControlNodeInfo(object sender, Syncfusion.Windows.Forms.Diagram.ControlNodeEventArgs evtArgs)
		{
			if(evtArgs.EventInfo == ControlNodeEventInfo.GetChildControl)
			{
				if(evtArgs.Node.Parent is CustomListSymbol)
				{
					ControlNode ctrlnode = evtArgs.Node as ControlNode;
					ctrlnode.ControlAssemblyName = typeof(ControlsGalore.Form1).Assembly.FullName;
					ctrlnode.ControlClassName = "ControlsGalore.CustomListBox";
				}
			}
			else if(evtArgs.EventInfo == ControlNodeEventInfo.ChildControlCreated)
			{
				ControlNode ctrlnode = evtArgs.Node as ControlNode;
				if(ctrlnode.Control is TextBox)
				{
					TextBox txtbox = ctrlnode.Control as TextBox;
					txtbox.Multiline = true;
					txtbox.Text = "This is a TextBox in a ControlNode";
				}
				else if(ctrlnode.Control is Button)
				{
					Button btn = ctrlnode.Control as Button;
					btn.Text = "Double Click to activate me";
					btn.Click += new EventHandler(this.ctrlNodeBtn_Click);
				}
			}
		}		

		// Use the ControlNodeTool to create a ControlNode initialized with a Windows Forms TextBox control
		private void miInsertTextBox_Click(object sender, System.EventArgs e)
		{
			ControlNode ctrlnode = new ControlNode();
			ctrlnode.ControlAssemblyName = "System.Windows.Forms";
			ctrlnode.ControlClassName = "System.Windows.Forms.TextBox";			
			ControlNodeTool ctrlnodetool = (ControlNodeTool)this.diagram1.Controller.GetTool("ControlNodeTool");
			ctrlnodetool.Node = ctrlnode;
			this.diagram1.Controller.ActivateTool(ctrlnodetool);
		}

		// Use the ControlNodeTool to create a ControlNode that initialized with a Windows Forms Button control
		private void miInsertButton_Click_2(object sender, System.EventArgs e)
		{
			ControlNode ctrlnode = new ControlNode();
			ctrlnode.ControlAssemblyName = "System.Windows.Forms";
			ctrlnode.ControlClassName = "System.Windows.Forms.Button";			
			ControlNodeTool ctrlnodetool = (ControlNodeTool)this.diagram1.Controller.GetTool("ControlNodeTool");
			ctrlnodetool.Node = ctrlnode;
			this.diagram1.Controller.ActivateTool(ctrlnodetool);
		}

		// Use the ControlNodeTool to insert an empty ControlNode. The PropertyEditor can be 
		// used to initialize the node's child control
		private void miInsertControlNode_Click(object sender, System.EventArgs e)
		{
			this.diagram1.ActivateTool("ControlNodeTool");		
		}
		
		private void ctrlNodeBtn_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("I am all wired up!", "ControlsGalore");
		}		
	}
}
